function webpackModule(options) {
	var me = this;
	me.config = options||{only:false};
    // Configure your plugin with options...
}
webpackModule.prototype.apply = function (compiler) {
	var me = this;
    compiler.plugin("emit", function (compilation, callback) {
        var path = require('path');
        for (var a in compilation.assets) {
            var p = path.parse(a);
            if (p.ext != ".js")
                continue;
            var name = p.dir+"/m."+p.base;
            var head = "define(function(){return ";
            var end = "});";
            var s = compilation.assets[a].source();
            var si = compilation.assets[a].size()
            if ( s.length >0 && s[0] == "!" ){
                s = s.substr(1);
                si--;
            }
            s = head + s + end;
            si = si + head.length + end.length;
            compilation.assets[name] = {
                source: function (params) {
                    return s;
                },
                size: function (params) {
                    return si;
                }
            };
			if ( me.config.only ){
				delete compilation.assets[a];
			}
        }
        callback();
    });
};
var tool={};
tool.findModules = function(mpath){
	var rd = require('rd');
	// 寻找传入路径下的js
	var pt = require('path');
	var base = pt.normalize(mpath+"/");
	var paths = rd.readSync(base);
	if ( !paths || paths.length < 1 )
		return {};
	
	var va = {};
	for( var i=0; i<paths.length; ++i ){
		var curPath = pt.normalize(paths[i]);
		var v = pt.parse(curPath)
		if ( v.ext != '.js' )
			continue;
		var shortPath = curPath.replace(base,'');
		var index = shortPath.indexOf(pt.sep);
		if ( index < 0 )
			continue;
		va[shortPath.substr(0,index)] = curPath;
	}
	return va;
};

module.exports = {
	tool:tool,
	plugin: webpackModule
}